-- 跳动数字
local BeatNumberUI = class("BeatLabel", function ()
    return ccui.Layout:create()
    -- body
end)

-- @params.font艺术字体
-- @params.time每次跳动时间
-- @params.times跳动次数
function BeatNumberUI:ctor(font, time, times)
    self.times = 10
    self.time = 0.1
    if type(times) == "number" then
        self.times = times
    end
    if type(time) == "number" then
        self.time = time
    end
    local label 
    if font ~= nil then       
        label = ccui.TextBMFont:create()
        label:setFntFile(font)              
    else
        local BaseLabel = require("app.uitab.common.text.BaseLabel")
        label = BaseLabel.new()
        label:setFontSize(FONT_SIZE_2)    
    end
    self:addChild(label)  
    self.label = label
end
-- @params.from总的跳动时间
-- @params.to跳动次数
-- @params.time每次跳动时间
-- @params.times跳动次数
function BeatNumberUI:play(from, to, time, times)
    if self.playing == true then
        return
    end
    if type(from) ~= "number" then
        return       
    end
    if type(to) ~= "number" then
        return       
    end
    
    if type(times) == "number" then
        self.times = times
    end
    if type(time) == "number" then
        self.time = time
    end

    if self.times < 1 then
        self.label:setString(tostring(to))
        return
    end
    self.label:setString(tostring(from))
    local gap = to - from
    local gapAbs = math.abs(gap)   
    if gapAbs < self.times then
        self.times = gap        
    end
    -- 一下预先存取跳动值
    local average = gapAbs/(self.times - 1)
    self.nums = {}    
    for i=1, self.times - 1 do
        local num       
        if gap > 0 then 
            num = math.floor(from + average * i) 
        else
            num = math.floor(from - average * i)
        end        
        self.nums[i] = tostring(num)
    end
    self.nums[#self.nums + 1] = tostring(to)
    self.count = 0
    self.playing = true

     local scheduler = require("framework.scheduler")
    self.sch = scheduler.scheduleGlobal(handler(self, self.enterframe), self.time) 
end

function BeatNumberUI:enterframe()   
    self.count = self.count + 1
    self.label:setString(self.nums[self.count])
    if self.count >= #self.nums then
        self:onExit()   
    end
end

-- 退出的时候清除
function BeatNumberUI:onExit()
    if self.playing == true then
        local scheduler = require("framework.scheduler")
        scheduler.unscheduleGlobal(self.sch)
        self.playing = false
    end 
end

return BeatNumberUI